
editthatpatch:
	ld a, (hl)
	and %01111111
	ld (cursize), a
	xor a
	ld (curbyte), a
	inc a
	ld (curchange), a
	ld a, (endofsprites)
	ld b, a
	ld a, c
	cp b
	jp nc, valuepatchchange
	call drawpatchinfo
ethatpatchloop:
	push hl
	ld a, (curbyte)
	add a, 8
	ld e, a
	ld d, 0
	add hl, de
	ld a, (hl)
	ld de, $fcb5
	ld (de), a
	ld de, $2001
	ld hl, changestring
	call drawstring
	ld a, (curchange)
	ld l, a
	xor a
	ld h, a
	ld de, $0504
	ld (_curRow), de
	call _dispAHL
	call waitkey
	ld b, 30
	call keyloop
	pop hl
	cp 10
	call z, copyit
	cp 11
	call z, copyit
	cp 2
	call z, goleftone
	cp 3
	call z, gorightone
	cp 4
	call z, changebytedown
	cp 1
	call z, changebyteup
	cp 6
	call z, dothechange
	cp 7
	call z, xorcurbyte
	cp 8
	call z, clearcurbyte
	cp 5
	jr z, exiteditorandsave
	cp 9
	jr nz, ethatpatchloop
	ld hl, loadstringtempmem
	jp loadstring
exiteditorandsave:
	jp savestring
goleftone:
	ld a, (curchange)
	rlca
bothchange:
	ld (curchange), a
	ld a, (cursize)
	cp 9
	call c, drawpatchinfo
	ret
gorightone:
	ld a, (curchange)
	rrca
	jr bothchange
changebytedown:
	ld a, (curbyte)
	or a
	ret z
	dec a
bothbyte:
	ld (curbyte), a
	jp drawpatchinfo
changebyteup:
	ld a, (cursize)
	dec a
	ld b, a
	ld a, (curbyte)
	cp b
	jr z, bothbyte
	inc a
	jr bothbyte
dothechange:
	push hl
	ld a, (curbyte)
	add a, 8
	ld e, a
	ld d, 0
	add hl, de
	ld a, (curchange)
	xor (hl)
	ld (hl), a
	pop hl
	jp drawpatchinfo
clearcurbyte:
	push hl
	ld a, (curbyte)
	add a, 8
	ld e, a
	ld d, 0
	add hl, de
	ld (hl), d
	pop hl
	jp drawpatchinfo
xorcurbyte:
	push hl
	ld a, (curbyte)
	add a, 8
	ld e, a
	ld d, 0
	add hl, de
	ld a, (hl)
	cpl
	ld (hl), a
	pop hl
	jp drawpatchinfo
copyit:
	push hl
	ld de, 8
	add hl, de
	ld de, $ca00
	cp 11
	jr nz, noexdehl
	ex de, hl
noexdehl:
	ld a, (cursize)
	ld c, a
	ld b, 0
	ldir
	pop hl
	jp drawpatchinfo


valuepatchchange:
	call drawvalue
vpchange:
	push hl
	ld b, 10
	call keyloop
	pop hl
	cp 8
	call z, changeleftbig
	cp 7
	call z, changerightbig
	cp 4
	call z, changebytedown2
	cp 1
	call z, changebyteup2
	cp 2
	call z, changechangeleft
	cp 3
	call z, changechangeright
	cp 6
	call z, dochange
	cp 5
	jp z, exiteditorandsave
	cp 9
	jr nz, vpchange
	ret
changebytedown2:
	ld a, (curbyte)
	cp 0
	ret z
	dec a
bothbyte2:
	ld (curbyte), a
	call drawvalue
	xor a
	ret
changebyteup2:
	ld a, (cursize)
	dec a
	ld b, a
	ld a, (curbyte)
	cp b
	jr z, bothbyte2
	inc a
	jr bothbyte2
dochange:
	push hl
	ld a, (curbyte)
	add a, 8
	ld e, a
	ld d, 0
	add hl, de
	ld a, (curchange)
	ld (hl), a
	pop hl
	call drawvalue
	xor a
	ret

changeleftbig:
	ld a, (curchange)
	sub 32
	jr bothchch
changerightbig:
	ld a, (curchange)
	add a, 32
	jr bothchch
changechangeleft:
	ld a, (curchange)
	dec a
bothchch
	ld (curchange), a
	call drawvalue
	xor a
	ret
changechangeright:
	ld a, (curchange)
	inc a
	jr bothchch

drawvalue:
	push hl
	call _clrLCD
	ld de, $0101
	ld hl, bytestring
	call drawstring
	ld a, (curbyte)
	ld l, a
	xor a
	ld h, a
	ld de, $0500
	ld (_curRow), de
	call _dispAHL
	ld de, $0801
	ld hl, byteinfostring
	call drawstring
	ld de, $1401
	call drawstring
	ld de, $1a01
	call drawstring
	pop hl
	push hl
	ld a, (curbyte)
	add a, 8
	ld e, a
	ld d, 0
	add hl, de
	ld a, (hl)
	push af
	ld l, a
	xor a
	ld h, a
	ld de, $0501
	ld (_curRow), de
	call _dispAHL
	pop af
	ld (binfomem), a
	ld de, $0850
	ld hl, binfomem
	call drawstring
	ld de, $2601
	ld hl, changestring
	call drawstring
	ld a, (curchange)
	ld l, a
	xor a
	ld h, a
	ld de, $0505
	ld (_curRow), de
	call _dispAHL
	ld a, (curchange)
	ld (binfomem), a
	ld de, $2650
	ld hl, binfomem
	call drawstring
	pop hl
	push hl
	ld de, 8
	add hl, de
	ld de, $ca00
	ld a, (cursize)
	ld c, a
	ld b, 0
	push de
	push bc
	ldir
	pop bc
	pop hl
	add hl, bc
	xor a
	ld (hl), a
	ld de, $3801
	ld hl, $ca00
	call drawstring
	pop hl
	ret

binfomem:
	.dw 0

drawpatchinfo:
	push hl
	call _clrLCD
	ld de, $0101
	ld hl, bytestring
	call drawstring
	ld a, (curbyte)
	ld l, a
	xor a
	ld h, a
	ld de, $0500
	ld (_curRow), de
	call _dispAHL
	ld de, $0801
	ld hl, byteinfostring
	call drawstring
	ld de, $0e01
	call drawstring
	ld de, $1401
	call drawstring
	pop hl
	push hl
	ld de, 8
	add hl, de
	ld a, (cursize)
	cp 9
	jr c, bigpatchblowup
	ld de, $fc09
dosmallicon:
	ex de, hl
	ld b, a
dpatchinfoloop:
	push bc
	ld a, (de)
	ld (hl), a
	ld bc, 16
	add hl, bc
	inc de
	pop bc
	djnz dpatchinfoloop
	pop hl
	xor a
	ret
bigpatchblowup:
	ld de, $0008
	ld b, a
bpblowuploop1:
	push bc
	ld b, 8
	ld c, %10000000
bpblowuploop2:
	push hl
	push de
	push bc
	ld a, (hl)
	ld hl, blackthing
	and c
	call nz, GridPutSprite
	pop bc
	rrc c
	pop de
	inc e
	pop hl
	djnz bpblowuploop2
	inc hl
	inc d
	ld e, $08
	pop bc
	djnz bpblowuploop1
	ld a, (curbyte)
	ld d, a
	ld a, (curchange)
	ld e, $08
	cp 1
	call z, on1
	cp 2
	call z, on2
	cp 4
	call z, on4
	cp 8
	call z, on8
	cp 16
	call z, on16
	cp 32
	call z, on32
	cp 64
	call z, on64
	ld hl, selectorsprite
	call GridPutSprite
	pop hl
	push hl
	ld de, 8
	add hl, de
	ld de, $ff83
	ld a, (cursize)
	jr dosmallicon
on1:
	inc e
on2:
	inc e
on4:
	inc e
on8:
	inc e
on16:
	inc e
on32:
	inc e
on64:
	inc e
	ret
blackthing:
	.db 255, 255, 255, 255, 255, 255, 255, 255
selectorsprite:
	.db %11100111
	.db %11100111
	.db %11000011
	.db %00011000
	.db %00011000
	.db %11000011
	.db %11100111
	.db %11100111


switchstatus:
	ld a, (hl)
	ld b, %10000000
	xor b
	ld (hl), a
	and %01111111
	ld (cursize), a
	inc hl
	inc hl
	inc hl
	inc hl
	inc hl
	inc hl
	ld c, (hl)
	inc hl
	ld b, (hl)
	inc hl
	push bc
	ld de, $8000
	or a
	sbc hl, de
	ld a, 1
	ld (dataword), hl
	ld hl, $8103
	rst 20h
	rst 10h
	ld a,b
	ex de,hl
	call _ahl_plus_2_pg3
	call _ahl_plus_2_pg3
	pop de
	add hl, de
	call c, inca
	push af
	push hl
	call _set_abs_src_addr
	ld a, 0
	ld hl, spritetempmem
	call _set_abs_dest_addr
	ld a, (cursize)
	ld l, a
	xor a
	ld h, a
	call _set_mm_num_bytes
	call _mm_ldir
	pop hl
	pop af
	call _set_abs_dest_addr
	ld a, 1
	ld hl, (dataword)
	call _set_abs_src_addr
	ld a, (cursize)
	ld l, a
	xor a
	ld h, a
	call _set_mm_num_bytes
	call _mm_ldir
	call _ram_page_1
	ld hl, (dataword)
	ld de, $8000
	add hl, de
	ex de, hl
	ld hl, spritetempmem
	ld a, (cursize)
	ld c, a
	ld b, 0
	ldir
	jp savestring

inca:
	inc a
	ret

drawpatchnames:
	call _clrLCD
	ld hl, spatchtext
	ld de, $0002
	call drawstring
	ld hl, $fc70
	call hline
	ld a, (spriteoffset)
	ld c, a
	ld a, (spritenum)
	sub c
	cp 8
	call nc, makeb8
	push af
	ld a, c
	call getstartofminipatch
	pop bc
	ld de, $0806
dpnloop:
	push bc
	push de
	call clearspot
	ld a, (hl)
	pop de
	push af
	and %10000000
	push de
	push hl
	ld hl, offstring
	rlca
	rlca
	rlca
	ld c, a
	ld b, 0
	add hl, bc
	ld e, 80
	call drawstring
	pop hl
	inc hl
	ld b, 5
	ld de, tempstringspot
dpnloop2:
	ld a, (hl)
	ld (de), a
	inc hl
	inc de
	djnz dpnloop2
	pop de
	pop af
	and %01111111
	add a, 2
	ld c, a
	ld b, 0
	add hl, bc
	push hl
	push de
	ld hl, tempstringspot
	ld a, (hl)
	cp 63
	call z, inchl
	call drawstring
	pop de
	ld a, d
	add a, 6
	ld d, a
	pop hl
	pop bc
	djnz dpnloop
	push de
	ld hl, nextstring
	call drawstring
	pop de
	ld c, d
	ld a, 1
	ld d, 6
	ld b, 8
	call blinkselect
	cp 255
	ret z
	ld c, a
	ld a, (spriteoffset)
	ld b, a
	ld a, (spritenum)
	sub b
	cp 8
	call nc, makeb8
	ld b, a
	ld a, c
	cp b
	jr z, nextpageofsprites
	cp 254
	jr z, nextpageofsprites
	ld a, (spriteoffset)
	add a, c
	push af
	call getstartofminipatch
	pop af
	ret

makeb8:
	ld a, 8
	ret
inchl:
	inc hl
	ret

getstartofminipatch:
	ld b, a
	ld hl, (startofpatches)
	cp 0
	jr z, skipthestupidloop2
dpnameloop:
	ld a, (hl)
	and %01111111
	ld e, a
	ld d, 0
	add hl, de
	ld de, 8
	add hl, de
	djnz dpnameloop
skipthestupidloop2:
	ret

nextpageofsprites:
	ld a, (spritenum)
	ld b, a
	ld a, (spriteoffset)
	add a, 8
	cp b
	call nc, resetoffset
	ld (spriteoffset), a
	jp drawpatchnames
resetoffset:
	xor a
	ret

;finds patches with the special header, lists them, lets you select one, then it loads that one
;into memory.
getpatch:
	call getnames					;store names of possible patches in the graph memory
	ld a, (patchnumber)
	cp 7
	call nc, make6patch				;maximum of 6 patches on the calc at once.
	ld (patchnumber), a
	ld b, a
	ld hl, $ca00					;names begin at ca00
	ld de, $1a05					;names start at (4, 26)
patchdrawloop:
	push bc
	push de
	call drawstring					;already moves hl to the next string, how convenient!
	pop de
	ld a, d							;add 6 to the y pos, to the next line
	add a, 6
	ld d, a
	pop bc
	djnz patchdrawloop
	ld a, (patchnumber)
	add a, a
	ld b, a
	add a, a
	add a, b
	add a, $14
	ld c, a							;take the number of patches, multiply it by 6, and add 18 to get the down limit
	ld b, $1a						;the up limit is 24
	ld d, 6							;increment a line at a time
	xor	a						;cursor goes with x at 0
	call blinkselect				;I love this subroutine :)
	cp 255
	ret z
	ld b, a
	ld hl, $ca00					;start at beginning
	or a
	jr z, skipfindloop					;this could be screwy!
getpatchnameloop:						;use cpir to attach a name to a selection
	push bc
	xor a
	cpir							;skip to each 0 at a time
	pop bc
	djnz getpatchnameloop
skipfindloop:
	push hl
	ld b, 0
getlengthloop:
	inc hl
	inc b
	ld a, (hl)						;increases b as it searches for a 0
	or a
	jr nz, getlengthloop
	ld a, b
	ld de, loadstringtempmem+1
	ld (de), a
	inc de
	pop hl
plantnameloop:						;b is already set for us!
	ld a, (hl)
	ld (de), a
	inc hl
	inc de
	djnz plantnameloop				;now we've got a string name to use to load the string!
	ld hl, loadstringtempmem
	jp loadstring
make6patch:
	ld a, 6
	ret

getnames:				;this routine gets names of patch files by searching for strings with a special header
						;and then copying the name of that string into the graph mem, where all the names are
						;temporarily stored.
	ld de, $ca00
	ld (dataword), de						;start name data at beginnning of graph mem
	call _RAM_Page_7
	ld hl, $bfff							;VAT 'starts' at $bfff on RAM page 7
getnames2:
	ld bc, (_endSymbolTable)
	inc bc
	or a
	sbc hl, bc
	ret c									;subtracts end (or beginning) of VAT from current position
	add hl, bc								;if there's a carry, then we are past the VAT
	ld a, (hl)
	dec hl
	dec hl
	dec hl
	dec hl
	dec hl									;get variable type, then decrease hl down to where
	cp $0c									;the name starts, if the type is $oc (a string)
	jr z, gotastring						;then we go to the gotastring routine
finishname:
	ld a, (hl)								;now we get the number of characters the current variable's name is...
	inc a
	ld e, a									;add one to go past the number byte and convert it to a 16 bit
	ld d, 0									;number...
	or a
	sbc hl, de								;...and subtract it to get to the next variable
	jr getnames2
gotastring:
	push hl									;save our position
	inc hl
	inc hl
	ld a, (hl)
	inc hl
	ld d, (hl)
	inc hl
	ld e,(hl)								;get the 24 bit number that points to the start of the string
	ex de,hl
	call _ahl_plus_2_pg3					;add two (you always add two, for some reason...)
	call _get_word_ahl						;then we put the two bytes that we find next into de
	ld a, e
	cp 255
	jr nz, backtosearch
	ld a, d
	cp 134
	jr nz, backtosearch						;check for the patch header, if not, go back to check for more strings
	call _RAM_Page_7						;switch back to the page 7 (we switched back there)
	pop hl
	push hl
	ld b, (hl)								;get the length of the current strings name+load de with where we
	ld de, (dataword)						;are in the name data
reversestringloop:
	dec hl
	ld a, (hl)								;since the name is stored backwards, we flip it back as we store
	ld (de), a								;it in temporary memory
	inc de
	djnz reversestringloop
	xor a
	ld (de), a								;add 0 since its a string
	inc de
	ld (dataword), de						;the next string will start on the next byte
	ld a, (patchnumber)
	inc a
	ld (patchnumber), a						;we've got another patch (if it is more than 6, then you never see it)
backtosearch:
	call _RAM_Page_7						;switch to page 7 (we didn't earlier unless it was the right string)
	pop hl
	jr finishname							;get our VAT position back and go back to the routine.



.end
